<template>
  <Dialog :title="dialogTitle" v-model="dialogVisible">
    <el-form
      ref="formRef"
      :model="formData"
      :rules="formRules"
      label-width="100px"
      v-loading="formLoading"
    >
      <el-form-item label="新闻标题" prop="newsTitle">
        <el-input v-model="formData.newsTitle" placeholder="请输入新闻标题" />
      </el-form-item>
      <el-form-item label="新闻描述" prop="newsDesc">
        <el-input v-model="formData.newsDesc" placeholder="请输入新闻描述" />
      </el-form-item>
      <el-form-item label="新闻内容" prop="newsContent">
        <Editor v-model="formData.newsContent" height="150px" />
      </el-form-item>
      <el-form-item label="新闻路径" prop="newsPath">
        <el-input v-model="formData.newsPath" placeholder="请输入新闻路径" />
      </el-form-item>
      <el-form-item label="封面图片" prop="coverImg">
        <el-input v-model="formData.coverImg" placeholder="请输入封面图片" />
      </el-form-item>
      <el-form-item label="新闻类型ID" prop="newsTypeId">
        <el-input v-model="formData.newsTypeId" placeholder="请输入新闻类型ID" />
      </el-form-item>
      <el-form-item label="发布时间" prop="publishTime">
        <el-date-picker
          v-model="formData.publishTime"
          type="date"
          value-format="x"
          placeholder="选择发布时间"
        />
      </el-form-item>
    </el-form>
    <template #footer>
      <el-button @click="submitForm" type="primary" :disabled="formLoading">确 定</el-button>
      <el-button @click="dialogVisible = false">取 消</el-button>
    </template>
  </Dialog>
</template>
<script setup lang="ts">
import { NewsApi, NewsVO } from '@/api/portal/news'

/** 新闻 表单 */
defineOptions({ name: 'NewsForm' })

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formType = ref('') // 表单的类型：create - 新增；update - 修改
const formData = ref({
  id: undefined,
  newsTitle: undefined,
  newsDesc: undefined,
  newsContent: undefined,
  newsPath: undefined,
  coverImg: undefined,
  newsTypeId: undefined,
  publishTime: undefined
})
const formRules = reactive({
  newsTitle: [{ required: true, message: '新闻标题不能为空', trigger: 'blur' }],
  newsContent: [{ required: true, message: '新闻内容不能为空', trigger: 'blur' }],
  newsPath: [{ required: true, message: '新闻路径不能为空', trigger: 'blur' }],
  newsTypeId: [{ required: true, message: '新闻类型ID不能为空', trigger: 'blur' }]
})
const formRef = ref() // 表单 Ref

/** 打开弹窗 */
const open = async (type: string, id?: number) => {
  dialogVisible.value = true
  dialogTitle.value = t('action.' + type)
  formType.value = type
  resetForm()
  // 修改时，设置数据
  if (id) {
    formLoading.value = true
    try {
      formData.value = await NewsApi.getNews(id)
    } finally {
      formLoading.value = false
    }
  }
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  await formRef.value.validate()
  // 提交请求
  formLoading.value = true
  try {
    const data = formData.value as unknown as NewsVO
    if (formType.value === 'create') {
      await NewsApi.createNews(data)
      message.success(t('common.createSuccess'))
    } else {
      await NewsApi.updateNews(data)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    id: undefined,
    newsTitle: undefined,
    newsDesc: undefined,
    newsContent: undefined,
    newsPath: undefined,
    coverImg: undefined,
    newsTypeId: undefined,
    publishTime: undefined
  }
  formRef.value?.resetFields()
}
</script>